commit:     17ec470a765292374100f78c18826f9d3fc1e562
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Fri Nov 18 06:18:18 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Fri Nov 18 06:18:18 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=17ec470a

app-misc/ca-certificates: add 20211016.3.85

Signed-off-by: Sam James <sam <AT> gentoo.org>

 app-misc/ca-certificates/Manifest                  |   1 +
 .../ca-certificates-20211016.3.85.ebuild           | 203 +++++++++++++++++++++
 2 files changed, 204 insertions(+)

diff --git a/app-misc/ca-certificates/Manifest 
b/app-misc/ca-certificates/Manifest
index f4d665b546ee..c956c29b9b7c 100644
--- a/app-misc/ca-certificates/Manifest
+++ b/app-misc/ca-certificates/Manifest
@@ -5,4 +5,5 @@ DIST nss-3.79.tar.gz 84830113 BLAKE2B 
f558592bf0983d3c44f11e079512865d310b4f4c22
 DIST nss-3.80.tar.gz 84841312 BLAKE2B 
6244193849a9277bc68c5225b4f836309bdf07bc415b23793d14c5343f5236b27bb7552fa7fb9975f410ea4732e9fc37185fee7bb950bf5d15b478f8bdec3ba7
 SHA512 
db05df17fea12bf3ec83882bf761663f8f10f3a8ce9a33519c7985d6003945068adb658250cf05d8b598c34ecb4ba7ea5cdc468d9cc7bc786aedb72d7be65923
 DIST nss-3.82.tar.gz 84708994 BLAKE2B 
59d3ace416c725933a07c51dc911f2fa11d55b1daddc5252a01ef3ae9df3375cbb199eff92e8e2bb364b9381ad1066c74d4f93c00900847f5234591bbbb29824
 SHA512 
6e0f28c3f776178ab2d97c6e2436aa10d72c9c2668aea1a6695ccf49e8c3c4cd2d266168508bcb456c655f2e692dceb44eae53c80d50076d7156db3deac70057
 DIST nss-3.83.tar.gz 84844191 BLAKE2B 
f2e26f69450cbd2c94c5efdd959cb19e874bcb63d09098406ef49f4997bd04bc0ee4bc285c1c4f0ec461194171342c7d31965ac7bc7eefc284783542dfe853b1
 SHA512 
550cf1116e39e58041feaa67913f570d791e8153cc0522ba7ae02e27a61e0a4e6a25224be0f25d51a842dc11c70d600263450ebff0a9fdaa2840bafa3fc9ddd5
+DIST nss-3.85.tar.gz 84717969 BLAKE2B 
644a51cd747078688233850bee6884b7ee30076411d783a4fb2982ffc35883f51784440d8c1c727251f664c4e5b5071be9881abc8315e0294d7da0cb8727e897
 SHA512 
97cfffa2beed1dba5d31e0c6e450553e5a8c78b427521640adb00c05d9d63cd64dc08388f0dbf96c93efb79f5daf4ba8db8d026b0b43d2e5c865a9b833fc77a1
 DIST nss-cacert-class1-class3-r2.patch 21925 BLAKE2B 
7627ff9a09f084c19d72d0490676865e3cab3ca7c920ae1ce4bea2db664f37fd0aa84fcda919809a516891ab2a62e2e7a43a9d6ada4c231adfe4c216525fac7d
 SHA512 
1ce6ff9ab310aaca9005eafb461338b291df8523cc7044e096cd75774ce746c26eed19ec6bb2643c6c67f94650f2f309463492d80a90568f38ce2557f8ada2f4

diff --git a/app-misc/ca-certificates/ca-certificates-20211016.3.85.ebuild 
b/app-misc/ca-certificates/ca-certificates-20211016.3.85.ebuild
new file mode 100644
index 000000000000..24e049209a49
--- /dev/null
+++ b/app-misc/ca-certificates/ca-certificates-20211016.3.85.ebuild
@@ -0,0 +1,203 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+# The Debian ca-certificates package merely takes the CA database as it exists
+# in the nss package and repackages it for use by openssl.
+#
+# The issue with using the compiled debs directly is two fold:
+# - they do not update frequently enough for us to rely on them
+# - they pull the CA database from nss tip of tree rather than the release
+#
+# So we take the Debian source tools and combine them with the latest nss
+# release to produce (largely) the same end result.  The difference is that
+# now we know our cert database is kept in sync with nss and, if need be,
+# can be sync with nss tip of tree more frequently to respond to bugs.
+
+# Where possible, bump to stable/LTS releases of NSS for the last part
+# of the version (when not using a pure Debian release).
+
+# When triaging user reports, refer to our wiki for tips:
+# https://wiki.gentoo.org/wiki/Certificates#Debugging_certificate_issues
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{8..11} )
+
+inherit python-any-r1
+
+if [[ ${PV} == *.* ]] ; then
+       # Compile from source ourselves.
+       PRECOMPILED=false
+
+       DEB_VER=$(ver_cut 1)
+       NSS_VER=$(ver_cut 2-)
+       RTM_NAME="NSS_${NSS_VER//./_}_RTM"
+else
+       # Debian precompiled version.
+       PRECOMPILED=true
+       inherit unpacker
+fi
+
+DESCRIPTION="Common CA Certificates PEM files"
+HOMEPAGE="https://packages.debian.org/sid/ca-certificates";
+NMU_PR=""
+if ${PRECOMPILED} ; then
+       
SRC_URI="mirror://debian/pool/main/c/${PN}/${PN}_${PV}${NMU_PR:++nmu}${NMU_PR}_all.deb"
+else
+       
SRC_URI="mirror://debian/pool/main/c/${PN}/${PN}_${DEB_VER}${NMU_PR:++nmu}${NMU_PR}.tar.xz
+               
https://archive.mozilla.org/pub/security/nss/releases/${RTM_NAME}/src/nss-${NSS_VER}.tar.gz
+               cacert? (
+                       
https://dev.gentoo.org/~whissi/dist/ca-certificates/nss-cacert-class1-class3-r2.patch
+               )"
+fi
+
+LICENSE="MPL-1.1"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~m68k ~mips ~ppc ~ppc64 
~riscv ~s390 ~sparc ~x86 ~x64-cygwin ~amd64-linux ~x86-linux ~ppc-macos 
~x64-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris ~x86-winnt"
+IUSE=""
+${PRECOMPILED} || IUSE+=" cacert"
+
+# c_rehash: we run `c_rehash`
+# debianutils: we run `run-parts`
+CDEPEND="app-misc/c_rehash
+       sys-apps/debianutils"
+
+BDEPEND="${CDEPEND}"
+if ! ${PRECOMPILED} ; then
+       BDEPEND+=" ${PYTHON_DEPS}"
+fi
+
+DEPEND=""
+if ${PRECOMPILED} ; then
+       DEPEND+=" !<sys-apps/portage-2.1.10.41"
+fi
+
+RDEPEND="${CDEPEND}
+       ${DEPEND}"
+
+S="${WORKDIR}"
+
+pkg_setup() {
+       # For the conversion to having it in CONFIG_PROTECT_MASK,
+       # we need to tell users about it once manually first.
+       [[ -f "${EPREFIX}"/etc/env.d/98ca-certificates ]] \
+               || ewarn "You should run update-ca-certificates manually after 
etc-update"
+
+       if ! ${PRECOMPILED} ; then
+               python-any-r1_pkg_setup
+       fi
+}
+
+src_unpack() {
+       if ! ${PRECOMPILED} ; then
+               default
+               # Initial 20200601 deb release had bad naming inside the debian 
source tarball.
+               DEB_S="${WORKDIR}/${PN}-${DEB_VER}"
+               DEB_BAD_S="${WORKDIR}/work"
+               if [[ -d "${DEB_BAD_S}" ]] && [[ ! -d "${DEB_S}" ]] ; then
+                       mv "${DEB_BAD_S}" "${DEB_S}"
+               fi
+       fi
+
+       # Do all the work in the image subdir to avoid conflicting with source
+       # dirs in ${WORKDIR}.  Need to perform everything in the offset #381937
+       mkdir -p "image/${EPREFIX}" || die
+       cd "image/${EPREFIX}" || die
+
+       ${PRECOMPILED} && unpacker_src_unpack
+}
+
+src_prepare() {
+       cd "image/${EPREFIX}" || die
+
+       if ! ${PRECOMPILED} ; then
+               mkdir -p usr/sbin || die
+               cp -p "${S}"/${PN}-${DEB_VER}/sbin/update-ca-certificates \
+                       usr/sbin/ || die
+
+               if use cacert ; then
+                       pushd "${S}"/nss-${NSS_VER} >/dev/null || die
+                       eapply "${DISTDIR}"/nss-cacert-class1-class3-r2.patch
+                       popd >/dev/null || die
+               fi
+       fi
+
+       default
+       eapply -p2 "${FILESDIR}"/${PN}-20150426-root.patch
+
+       pushd "${S}/${PN}-${DEB_VER}" >/dev/null || die
+       eapply "${FILESDIR}"/${PN}-20211016.3.72-no-cryptography.patch
+       popd >/dev/null || die
+
+       local relp=$(echo "${EPREFIX}" | sed -e 's:[^/]\+:..:g')
+       sed -i \
+               -e '/="$ROOT/s:ROOT:ROOT'"${EPREFIX}"':' \
+               -e '/RELPATH="\.\./s:"$:'"${relp}"'":' \
+               -e 's/openssl rehash/c_rehash/' \
+               usr/sbin/update-ca-certificates || die
+}
+
+src_compile() {
+       cd "image/${EPREFIX}" || die
+
+       if ! ${PRECOMPILED} ; then
+               local d="${S}/${PN}-${DEB_VER}/mozilla" c="usr/share/${PN}"
+
+               # Grab the database from the nss sources.
+               cp 
"${S}"/nss-${NSS_VER}/nss/lib/ckfw/builtins/{certdata.txt,nssckbi.h} "${d}" || 
die
+               emake -C "${d}"
+
+               # Now move the files to the same places that the precompiled 
would.
+               mkdir -p etc/ssl/certs \
+                       etc/ca-certificates/update.d \
+                       "${c}"/mozilla \
+                       || die
+               if use cacert ; then
+                       mkdir -p "${c}"/cacert.org || die
+                       mv "${d}"/CA_Cert_Signing_Authority.crt \
+                               "${c}"/cacert.org/cacert.org_class1.crt || die
+                       mv "${d}"/CAcert_Class_3_Root.crt \
+                               "${c}"/cacert.org/cacert.org_class3.crt || die
+               fi
+               mv "${d}"/*.crt "${c}"/mozilla/ || die
+       else
+               mv usr/share/doc/{ca-certificates,${PF}} || die
+       fi
+
+       (
+               echo "# Automatically generated by ${CATEGORY}/${PF}"
+               echo "# $(date -u)"
+               echo "# Do not edit."
+               cd "${c}" || die
+               find * -name '*.crt' | LC_ALL=C sort
+       ) > etc/ca-certificates.conf
+
+       sh usr/sbin/update-ca-certificates --root "${S}/image" || die
+}
+
+src_install() {
+       cp -pPR image/* "${D}"/ || die
+       if ! ${PRECOMPILED} ; then
+               cd ${PN}-${DEB_VER} || die
+               doman sbin/*.8
+               dodoc debian/README.* examples/ca-certificates-local/README
+       fi
+
+       echo 'CONFIG_PROTECT_MASK="/etc/ca-certificates.conf"' > 
98ca-certificates || die
+       doenvd 98ca-certificates
+}
+
+pkg_postinst() {
+       if [[ -d "${EROOT}/usr/local/share/ca-certificates" ]] ; then
+               # If the user has local certs, we need to rebuild again
+               # to include their stuff in the db.
+               # However it's too overzealous when the user has custom certs 
in place.
+               # --fresh is to clean up dangling symlinks
+               "${EROOT}"/usr/sbin/update-ca-certificates --root "${ROOT}"
+       fi
+
+       if [[ -n "$(find -L "${EROOT}"/etc/ssl/certs/ -type l)" ]] ; then
+               ewarn "Removing the following broken symlinks:"
+               ewarn "$(find -L "${EROOT}"/etc/ssl/certs/ -type l -printf '%p 
-> %l\n' -delete)"
+       fi
+}

Reply via email to